
var LOGFILE_NAME = "event-mailer.log";
var l = new Logger(LOGFILE_NAME);


var deviceText=""// %device% 
var devicedsidText="";// %devicedsid%
var zoneidText="";// %zoneid%
var zoneText="";// %zone%
var groupidText="";// %groupid%
var groupText="";// %group%
var sceneidText="";// %sceneid%
var sceneText="";// %scene%
var tippIdText="";// %tippid%
var tippText="";// %tipp%
var highlevelText="";// %highlevelevent%
// %timestamp%

function addLeadingZeroes(number, count) {
    var result = '' + number;
    while (result.length < count) {
        result = '0' + result;
    }
    return result;
}

function timeStamp() {
	var oDate = new Date();
	return oDate.getDate() + "." + (oDate.getMonth() + 1) + "."
			+ oDate.getFullYear() + " " + oDate.getHours() + ":"
			+ addLeadingZeroes(oDate.getMinutes(),2);
}

function replaceTags(sText)
{
    sText=unescape(sText);
	sText=sText.replace("%device%",deviceText);
	sText=sText.replace("%devicedsid%",devicedsidText);
	sText=sText.replace("%zoneid%",zoneidText);
	sText=sText.replace("%zone%",zoneText);
	sText=sText.replace("%groupid%",groupidText);
	sText=sText.replace("%group%",groupText);
	sText=sText.replace("%sceneid%",sceneidText);
	sText=sText.replace("%scene%",sceneText);
	sText=sText.replace("%tippid%",tippIdText);
	sText=sText.replace("%tipp%",tippText);
	sText=sText.replace("%highlevelevent%",highlevelText);
	sText=sText.replace("%timestamp%",timeStamp());
	return sText;
}

function sendMyMail(baseNode)
{
	l.logln("Email-Mailer: sending + " + baseNode.getPath());
	var mailParamNodes = baseNode.getChild('message');
	
	if (mailParamNodes.getChild('messageType')!=null) {
		if (mailParamNodes.getChild('messageType').getValue()=='email') {
			var parameter={};
			var prop = mailParamNodes.getChild('receiver');
			var to=prop.getValue();
			prop = mailParamNodes.getChild('messageBody');
			var body=replaceTags(prop.getValue());
			prop = mailParamNodes.getChild('subject');
			var subject=replaceTags(prop.getValue());
			l.logln("Email-Mailer: sende Email an: " + to + " Subject: " +subject + " Body: "+ body);
			var evt = new Event("eventmailerexecute",{'to':to,'body':body,'subject':subject,'from':'dSS-Benachrichtigung'});			
			evt.raise();
		} 
	}
}

function getDefaultNameForScene(zoneID,group,scene)
{
	var defaultName="Stimmung Nr. " + scene;
	
	switch (scene)
	{
		case 67:
			defaultName='Standby';
		break;
		case 64:
			defaultName='Auto Standby';
		break;
		case 68:
			defaultName='Deep Off';
		break;
		case 69:
			defaultName='Schlafen';
		break;
		case 70:
			defaultName='Aufwachen';
		break;
		case 72:
			defaultName='Gehen';
		break;
		case 71:
			defaultName='Kommen';
		break;
		case 73:
			defaultName='Klingel';
		break;
		case 65:
			defaultName='Panik';
		break;
		case 0:
			if (group==2)
				defaultName='Zu';
			else
				defaultName='Aus';
		break;
		case 5:
			if (group==2)
				defaultName='Auf';
			else
				defaultName='Stimmung 1';
		break;
		case 17:
			defaultName='Stimmung 2';
		break;
		case 18:
			defaultName='Stimmung 3';
		break;
		case 19:
			defaultName='Stimmung 4';
		break;
		case 1:
			if (group==2)
				defaultName='Bereich 1 zu';
			else
				defaultName='Bereich 1 aus';
		break;
		case 6:
			if (group==2)
				defaultName='Bereich 1 auf';
			else
				defaultName='Bereich 1 ein';
		break;
		case 2:
			if (group==2)
				defaultName='Bereich 2 zu';
			else
				defaultName='Bereich 2 aus';
		break;
		case 7:
			if (group==2)
				defaultName='Bereich 2 auf';
			else
				defaultName='Bereich 2 ein';
		break;
		case 3:
			if (group==2)
				defaultName='Bereich 3 zu';
			else
				defaultName='Bereich 3 aus';
		break;
		case 8:
			if (group==2)
				defaultName='Bereich 3 auf';
			else
				defaultName='Bereich 3 ein';
		break;
		case 4:
			if (group==2)
				defaultName='Bereich 4 zu';
			else
				defaultName='Bereich 4 aus';
		break;
		case 9:
			if (group==2)
				defaultName='Bereich 4 auf';
			else
				defaultName='Bereich 4 ein';
		break;
		case 32:
			defaultName='Stimmung 10';
		break;
		case 33:
			defaultName='Stimmung 11';
		break;
		case 34:
			defaultName='Stimmung 20';
		break;
		case 35:
			defaultName='Stimmung 21';
		break;
		case 36:
			defaultName='Stimmung 30';
		break;
		case 37:
			defaultName='Stimmung 31';
		break;
		case 38:
			defaultName='Stimmung 40';
		break;
		case 39:
			defaultName='Stimmung 41';
		break;
		case 20:
			defaultName='Stimmung 12';
		break;
		case 21:
			defaultName='Stimmung 13';
		break;
		case 22:
			defaultName='Stimmung 14';
		break;
		case 23:
			defaultName='Stimmung 22';
		break;
		case 24:
			defaultName='Stimmung 23';
		break;
		case 25:
			defaultName='Stimmung 24';
		break;
		case 26:
			defaultName='Stimmung 32';
		break;
		case 27:
			defaultName='Stimmung 33';
		break;
		case 28:
			defaultName='Stimmung 34';
		break;
		case 29:
			defaultName='Stimmung 42';
		break;
		case 30:
			defaultName='Stimmung 43';
		break;
		case 31:
			defaultName='Stimmung 44';
		break;
	}
	return defaultName;
}

function getGroupName(id)
{
	groupidText=""+id;
	switch(groupidText)
	{
	case "1":
		groupText="Licht";
		break;
	case "2":
		groupText="Schatten";
		break;
	case "3":
		groupText="Klima";
		break;
	case "4":
		groupText="Audio";
		break;
	case "5":
		groupText="Video";
		break;
	case "6":
		groupText="Sicherheit";
		break;
	case "7":
		groupText="Zugang";
		break;
	case "8":
		groupText="Joker";
		break;
	}
}

function getZoneName(zoneID)
{
	zoneText=Property.getProperty("/apartment/zones/zone" + zoneID +"/name");
	zoneidText=zoneID;
}

function getDeviceName(dsid){
	devicedsidText=dsid;
	var fDeviceNode=getDevices().byDSID("" + dsid);
	if (fDeviceNode!=null) {
		deviceText=fDeviceNode.name;
		getZoneName(fDeviceNode.zoneID);
		getGroupName(fDeviceNode.getPropertyNode().getChild('button/activeGroup').getValue());
	}
}

Property.load();

if (raisedEvent.name=="event-mailer")
	if (raisedEvent.parameter.actions!=null) {
        l.logln('action : ' + raisedEvent.parameter.actions);
		if (raisedEvent.parameter.id!=null)
		    if  (raisedEvent.parameter.actions=="test") {
				var sendingProperty = Property.getNode('values/' + raisedEvent.parameter.id);
				if (sendingProperty !=null)
					sendMyMail(sendingProperty);
			}
		if  (raisedEvent.parameter.actions=="execute") {
		    l.logln('action : ' + raisedEvent.parameter.path);
            var sendingProperty = Property.getNode(raisedEvent.parameter.path);
            if (sendingProperty !=null)
                sendMyMail(sendingProperty);
		}
	}

/*
if (raisedEvent.name == 'callScene') {
    var deviceText=""// %device% 
    var devicedsidText="";// %devicedsid%
    var zoneidText="";// %zoneid%
    var zoneText="";// %zone%
    var groupidText="";// %groupid%
    var groupText="";// %group%
    var sceneidText="";// %sceneid%
    var sceneText="";// %scene%
    var tippIdText="";// %tippid%
    var tippText="";// %tipp%   
    checkScene();   
}

if (raisedEvent.name == 'buttonClick') {
    checkDevice();
}

if (raisedEvent.name == 'highlevelevent') {
    highlevelText=unescape(raisedEvent.parameter.name);
    checkHighlevel();
}
*/

/*
function checkDeviceScene()
{
    var fSendMail=false;    
    var dsid = raisedEvent.source.dsid;
    var scene = raisedEvent.parameter.sceneID;
    if (scene == null)
        return;
    if (dsid == null)
        return;
    l.logln("Email-Mailer: checkDeviceScene " +scene +  " "+dsid );

    getDeviceName(dsid);
    if (scene==50)
    {
        tippIdText="11";// %tippid%
        tippText="Lokal aus";// %tipp%  
    } else if (scene==51)
        {
            tippIdText="12";// %tippid%
            tippText="Lokal an";// %tipp%   
        } else {
            sceneidText="" + scene;
            sceneText = getDefaultNameForScene(0,1,scene);
        }
    
    var sendingProperty = Property.getNode('values');
    if (sendingProperty) {
        var sendingSubProp = sendingProperty.getChildren();
        for ( var iIndex = 0; iIndex < sendingSubProp.length; iIndex++) {

            var baseProp = sendingSubProp[iIndex];
            var fBreak = false;
            if (baseProp.getChild('disabled')!=null)
                if (baseProp.getChild('disabled').getValue() == true)
                    fBreak = true;

            if (!fBreak) {
                var triggerBase = baseProp.getChild('triggers');
                if (triggerBase!=null)
                {
                    var oChildren=triggerBase.getChildren();
                    if (oChildren!=null)
                        for (var kIndex=0;kIndex<oChildren.length;kIndex++) {
                            triggerProp=oChildren[kIndex]
                            if (triggerProp.getChild('type')) 
                                if (triggerProp.getChild('type').getValue()=='device-scene') {
                                var triggerDSID = triggerProp.getChild('dsid');
                                var triggerSCENE = triggerProp.getChild('scene');
                                if (triggerDSID != null)
                                    if (triggerSCENE != null) {
                                        var sDSID=triggerDSID.getValue();
                                        var iSCENE=triggerSCENE.getValue();
                                        if ((sDSID=="-1" )|| (sDSID == dsid))
                                            if ((iSCENE == scene) ||(iSCENE==-1))  {
                                                l.logln("Email-Mailer: dSID: " + sDSID + " Scene: " + iSCENE );
                                                if (fSendMail==false)
                                                    sendMyMail(baseProp);
                                                fSendMail=true;
                                            }
                                        }
                            }
                    }
                }
            }
        }
    }

}
*/
/*
function checkScene() {
    var fSendMail=false;
    if (raisedEvent.source.isDevice) {
        checkDeviceScene();
        return;
    }
    var zone = raisedEvent.source.zoneID;
    var group = raisedEvent.source.groupID;
    var scene = raisedEvent.parameter.sceneID;
    if (zone == null)
        return;
    if (group == null)
        return;
    if (scene == null)
        return;
    getZoneName(zone);
    getGroupName(group);

    if (raisedEvent.parameter.originDeviceID!=null) {
        devicedsidText=raisedEvent.parameter.originDeviceID;
        var fDeviceNode=getDevices().byDSID("" + raisedEvent.parameter.originDeviceID);
        if (fDeviceNode!=null) 
            deviceText=fDeviceNode.name;
    }

    sceneidText="" + scene;
    sceneText = getDefaultNameForScene(zone,group,scene);
    
    var oProp=Property.getProperty("/apartment/zones/zone" + zone +"/groups/group" + group + "/scenes/scene" + scene + "/name");    
    if (oProp!=null)
    {
        sceneText += " - " + oProp;
    }
    l.logln("Email-Mailer: checkScene " +zone +  " "+group +" " + scene);
    
    var sendingProperty = Property.getNode('values');
    if (sendingProperty) {
        var sendingSubProp = sendingProperty.getChildren();
        for ( var iIndex = 0; iIndex < sendingSubProp.length; iIndex++) {

            var baseProp = sendingSubProp[iIndex];
            var fBreak = false;
            if (baseProp.getChild('disabled')!=null)
                if (baseProp.getChild('disabled').getValue() == true)
                    fBreak = true;

            if (!fBreak) {
                var triggerBase = baseProp.getChild('triggers');
                if (triggerBase!=null)
                {
                    var oChildren=triggerBase.getChildren();
                    if (oChildren!=null)
                        for (var kIndex=0;kIndex<oChildren.length;kIndex++) {
                            triggerProp=oChildren[kIndex]
                            if (triggerProp.getChild('type')) 
                                if (triggerProp.getChild('type').getValue()=='zone-scene') {
                                    var triggerZone = triggerProp.getChild('zone');
                                    var triggerGroup = triggerProp.getChild('group');
                                    var triggerScene = triggerProp.getChild('scene');
                                    if (triggerZone != null)
                                        if (triggerGroup != null)
                                            if (triggerScene != null) {
                                                var iZone=triggerZone.getValue();
                                                var iGroup=triggerGroup.getValue();
                                                var iScene=triggerScene.getValue();
                                                l.logln("Email-Mailer: checkScene " +iZone +  " "+iGroup +" " + iScene);
                                                
                                                if ((iZone==-1)|| (iZone == zone))
                                                    if ((iGroup == group) ||(iGroup==-1))
                                                        if ((iScene == scene)||(iScene==-1)) {
                                                            l.logln("Email-Mailer: Zone: " + zone + " Gruppe: " + group + " Szene: "+scene);
                                                            if (fSendMail==false)
                                                                sendMyMail(baseProp);
                                                            fSendMail=true;
                                                        }
                                            }
                                }
                    }
                }
            }
        }
    }
}
*/

/*
function checkDevice() {
    var fSendMail=false;    
    var dsid = raisedEvent.source.dsid;
    var clickType = raisedEvent.parameter.clickType;
    
    getDeviceName(dsid);
    
    
    tippIdText="" + clickType;
    switch(tippIdText)
    {
        case "0":
        case "7":
            tippText="Tipp 1x";
            break;
        case "1":
        case "8":
            tippText="Tipp 2x";
            break;
        case "2":
        case "9":
            tippText="Tipp 3x";
            break;
        case "3":
            tippText="Tipp 4x";
            break;
        case "10":
            tippText="Kurz-Lang";
            break;
        case "6":
            tippText="Halten";
            break;
    }
    
    if (dsid == null)
        return;
    if (clickType == null)
        return;
    l.logln("Email-Mailer: checkDevice " +clickType +  " "+dsid );

    var sendingProperty = Property.getNode('values');
    if (sendingProperty) {
        var sendingSubProp = sendingProperty.getChildren();
        for ( var iIndex = 0; iIndex < sendingSubProp.length; iIndex++) {

            var baseProp = sendingSubProp[iIndex];
            var fBreak = false;
            if (baseProp.getChild('disabled')!=null)
                if (baseProp.getChild('disabled').getValue() == true)
                    fBreak = true;

            if (!fBreak) {
                var triggerBase = baseProp.getChild('triggers');
                if (triggerBase!=null)
                {
                    var oChildren=triggerBase.getChildren();
                    if (oChildren!=null)
                        for (var kIndex=0;kIndex<oChildren.length;kIndex++) {
                            triggerProp=oChildren[kIndex]
                            if (triggerProp.getChild('type')) 
                                if (triggerProp.getChild('type').getValue()=='device-msg') {
                                var triggerDSID = triggerProp.getChild('dsid');
                                var triggerMSG = triggerProp.getChild('msg');
                                if (triggerDSID != null)
                                    if (triggerMSG != null) {
                                        var sDSID=triggerDSID.getValue();
                                        var iMSG=triggerMSG.getValue();
                                        if ((sDSID=="-1" )|| (sDSID == dsid))
                                            if ((iMSG == clickType) ||(iMSG==-1))  {
                                                l.logln("Email-Mailer: dSID: " + sDSID + " Klick: " + iMSG );
                                                if (fSendMail==false)
                                                    sendMyMail(baseProp);
                                                fSendMail=true;
                                            }
                                        }
                            }
                    }
                }
            }
        }
    }
}
*//*
function checkHighlevel() {
    var fSendMail=false;    
    var name = unescape(raisedEvent.parameter.name);
    if (name == null)
        return;
    l.logln("Email-Mailer: checkHighlevel " +name);

    var sendingProperty = Property.getNode('values');
    if (sendingProperty) {
        var sendingSubProp = sendingProperty.getChildren();
        for ( var iIndex = 0; iIndex < sendingSubProp.length; iIndex++) {

            var baseProp = sendingSubProp[iIndex];
            var fBreak = false;
            if (baseProp.getChild('disabled')!=null)
                if (baseProp.getChild('disabled').getValue() == true)
                    fBreak = true;

            if (!fBreak) {
                var triggerBase = baseProp.getChild('triggers');
                if (triggerBase!=null)
                {
                    var oChildren=triggerBase.getChildren();
                    if (oChildren!=null)
                        for (var kIndex=0;kIndex<oChildren.length;kIndex++) {
                            triggerProp=oChildren[kIndex]
                            if (triggerProp.getChild('type')) 
                                if (triggerProp.getChild('type').getValue()=='custom-event') {
                                var triggerEvent = triggerProp.getChild('event');
                                if (triggerEvent != null) {
                                    var sEvent=triggerEvent.getValue();
                                    if (name == sEvent) {
                                        l.logln("Email-Mailer: Event: " + name );
                                        if (fSendMail==false)
                                            sendMyMail(baseProp);
                                        fSendMail=true;
                                    }
                                }
                            }
                        }
                }
            }
        }
    }
}
*/